package cn.com.infosec.asn1.crmf;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.util.Enumeration;

public class CertReqMsg extends ASN1Encodable {
   private CertRequest certReq;
   private ProofOfPossession pop;
   private ASN1Sequence regInfo;

   private CertReqMsg(ASN1Sequence seq) {
      Enumeration seq1;
      this.certReq = CertRequest.getInstance((seq1 = seq.getObjects()).nextElement());

      while(seq1.hasMoreElements()) {
         Object var2;
         if ((var2 = seq1.nextElement()) instanceof ASN1TaggedObject) {
            this.pop = ProofOfPossession.getInstance(var2);
         } else {
            this.regInfo = ASN1Sequence.getInstance(var2);
         }
      }

   }

   public static CertReqMsg getInstance(Object o) {
      if (o instanceof CertReqMsg) {
         return (CertReqMsg)o;
      } else if (o instanceof ASN1Sequence) {
         return new CertReqMsg((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   private void addOptional(ASN1EncodableVector v, ASN1Encodable obj) {
      if (obj != null) {
         v.add(obj);
      }

   }

   public CertRequest getCertReq() {
      return this.certReq;
   }

   public ProofOfPossession getPop() {
      return this.pop;
   }

   public AttributeTypeAndValue[] getRegInfo() {
      ASN1Sequence var1;
      if ((var1 = this.regInfo) == null) {
         return null;
      } else {
         int var4;
         AttributeTypeAndValue[] var2 = new AttributeTypeAndValue[var4 = var1.size()];

         for(int var3 = 0; var3 != var4; ++var3) {
            var2[var3] = AttributeTypeAndValue.getInstance(this.regInfo.getObjectAt(var3));
         }

         return var2;
      }
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10004 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10004.add(this.certReq);
      this.addOptional(var1, this.pop);
      this.addOptional(var1, this.regInfo);
      return new DERSequence(var1);
   }
}
